part of 'generated.dart';

class ListRecentPaymentsByStaffIdVariablesBuilder {
  String staffId;
  Optional<int> _offset = Optional.optional(nativeFromJson, nativeToJson);
  Optional<int> _limit = Optional.optional(nativeFromJson, nativeToJson);

  final FirebaseDataConnect _dataConnect;  ListRecentPaymentsByStaffIdVariablesBuilder offset(int? t) {
   _offset.value = t;
   return this;
  }
  ListRecentPaymentsByStaffIdVariablesBuilder limit(int? t) {
   _limit.value = t;
   return this;
  }

  ListRecentPaymentsByStaffIdVariablesBuilder(this._dataConnect, {required  this.staffId,});
  Deserializer<ListRecentPaymentsByStaffIdData> dataDeserializer = (dynamic json)  => ListRecentPaymentsByStaffIdData.fromJson(jsonDecode(json));
  Serializer<ListRecentPaymentsByStaffIdVariables> varsSerializer = (ListRecentPaymentsByStaffIdVariables vars) => jsonEncode(vars.toJson());
  Future<QueryResult<ListRecentPaymentsByStaffIdData, ListRecentPaymentsByStaffIdVariables>> execute() {
    return ref().execute();
  }

  QueryRef<ListRecentPaymentsByStaffIdData, ListRecentPaymentsByStaffIdVariables> ref() {
    ListRecentPaymentsByStaffIdVariables vars= ListRecentPaymentsByStaffIdVariables(staffId: staffId,offset: _offset,limit: _limit,);
    return _dataConnect.query("listRecentPaymentsByStaffId", dataDeserializer, varsSerializer, vars);
  }
}

@immutable
class ListRecentPaymentsByStaffIdRecentPayments {
  final String id;
  final String? workedTime;
  final EnumValue<RecentPaymentStatus>? status;
  final String staffId;
  final String applicationId;
  final String invoiceId;
  final Timestamp? createdAt;
  final Timestamp? updatedAt;
  final String? createdBy;
  final ListRecentPaymentsByStaffIdRecentPaymentsApplication application;
  final ListRecentPaymentsByStaffIdRecentPaymentsInvoice invoice;
  ListRecentPaymentsByStaffIdRecentPayments.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  workedTime = json['workedTime'] == null ? null : nativeFromJson<String>(json['workedTime']),
  status = json['status'] == null ? null : recentPaymentStatusDeserializer(json['status']),
  staffId = nativeFromJson<String>(json['staffId']),
  applicationId = nativeFromJson<String>(json['applicationId']),
  invoiceId = nativeFromJson<String>(json['invoiceId']),
  createdAt = json['createdAt'] == null ? null : Timestamp.fromJson(json['createdAt']),
  updatedAt = json['updatedAt'] == null ? null : Timestamp.fromJson(json['updatedAt']),
  createdBy = json['createdBy'] == null ? null : nativeFromJson<String>(json['createdBy']),
  application = ListRecentPaymentsByStaffIdRecentPaymentsApplication.fromJson(json['application']),
  invoice = ListRecentPaymentsByStaffIdRecentPaymentsInvoice.fromJson(json['invoice']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStaffIdRecentPayments otherTyped = other as ListRecentPaymentsByStaffIdRecentPayments;
    return id == otherTyped.id && 
    workedTime == otherTyped.workedTime && 
    status == otherTyped.status && 
    staffId == otherTyped.staffId && 
    applicationId == otherTyped.applicationId && 
    invoiceId == otherTyped.invoiceId && 
    createdAt == otherTyped.createdAt && 
    updatedAt == otherTyped.updatedAt && 
    createdBy == otherTyped.createdBy && 
    application == otherTyped.application && 
    invoice == otherTyped.invoice;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, workedTime.hashCode, status.hashCode, staffId.hashCode, applicationId.hashCode, invoiceId.hashCode, createdAt.hashCode, updatedAt.hashCode, createdBy.hashCode, application.hashCode, invoice.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    if (workedTime != null) {
      json['workedTime'] = nativeToJson<String?>(workedTime);
    }
    if (status != null) {
      json['status'] = 
    recentPaymentStatusSerializer(status!)
    ;
    }
    json['staffId'] = nativeToJson<String>(staffId);
    json['applicationId'] = nativeToJson<String>(applicationId);
    json['invoiceId'] = nativeToJson<String>(invoiceId);
    if (createdAt != null) {
      json['createdAt'] = createdAt!.toJson();
    }
    if (updatedAt != null) {
      json['updatedAt'] = updatedAt!.toJson();
    }
    if (createdBy != null) {
      json['createdBy'] = nativeToJson<String?>(createdBy);
    }
    json['application'] = application.toJson();
    json['invoice'] = invoice.toJson();
    return json;
  }

  ListRecentPaymentsByStaffIdRecentPayments({
    required this.id,
    this.workedTime,
    this.status,
    required this.staffId,
    required this.applicationId,
    required this.invoiceId,
    this.createdAt,
    this.updatedAt,
    this.createdBy,
    required this.application,
    required this.invoice,
  });
}

@immutable
class ListRecentPaymentsByStaffIdRecentPaymentsApplication {
  final String id;
  final EnumValue<ApplicationStatus> status;
  final ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRole shiftRole;
  ListRecentPaymentsByStaffIdRecentPaymentsApplication.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  status = applicationStatusDeserializer(json['status']),
  shiftRole = ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRole.fromJson(json['shiftRole']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStaffIdRecentPaymentsApplication otherTyped = other as ListRecentPaymentsByStaffIdRecentPaymentsApplication;
    return id == otherTyped.id && 
    status == otherTyped.status && 
    shiftRole == otherTyped.shiftRole;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, status.hashCode, shiftRole.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['status'] = 
    applicationStatusSerializer(status)
    ;
    json['shiftRole'] = shiftRole.toJson();
    return json;
  }

  ListRecentPaymentsByStaffIdRecentPaymentsApplication({
    required this.id,
    required this.status,
    required this.shiftRole,
  });
}

@immutable
class ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRole {
  final Timestamp? startTime;
  final Timestamp? endTime;
  final double? hours;
  final double? totalValue;
  final ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRoleRole role;
  final ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRoleShift shift;
  ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRole.fromJson(dynamic json):
  
  startTime = json['startTime'] == null ? null : Timestamp.fromJson(json['startTime']),
  endTime = json['endTime'] == null ? null : Timestamp.fromJson(json['endTime']),
  hours = json['hours'] == null ? null : nativeFromJson<double>(json['hours']),
  totalValue = json['totalValue'] == null ? null : nativeFromJson<double>(json['totalValue']),
  role = ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRoleRole.fromJson(json['role']),
  shift = ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRoleShift.fromJson(json['shift']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRole otherTyped = other as ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRole;
    return startTime == otherTyped.startTime && 
    endTime == otherTyped.endTime && 
    hours == otherTyped.hours && 
    totalValue == otherTyped.totalValue && 
    role == otherTyped.role && 
    shift == otherTyped.shift;
    
  }
  @override
  int get hashCode => Object.hashAll([startTime.hashCode, endTime.hashCode, hours.hashCode, totalValue.hashCode, role.hashCode, shift.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    if (startTime != null) {
      json['startTime'] = startTime!.toJson();
    }
    if (endTime != null) {
      json['endTime'] = endTime!.toJson();
    }
    if (hours != null) {
      json['hours'] = nativeToJson<double?>(hours);
    }
    if (totalValue != null) {
      json['totalValue'] = nativeToJson<double?>(totalValue);
    }
    json['role'] = role.toJson();
    json['shift'] = shift.toJson();
    return json;
  }

  ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRole({
    this.startTime,
    this.endTime,
    this.hours,
    this.totalValue,
    required this.role,
    required this.shift,
  });
}

@immutable
class ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRoleRole {
  final String id;
  final String name;
  final double costPerHour;
  ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRoleRole.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  name = nativeFromJson<String>(json['name']),
  costPerHour = nativeFromJson<double>(json['costPerHour']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRoleRole otherTyped = other as ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRoleRole;
    return id == otherTyped.id && 
    name == otherTyped.name && 
    costPerHour == otherTyped.costPerHour;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, name.hashCode, costPerHour.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['name'] = nativeToJson<String>(name);
    json['costPerHour'] = nativeToJson<double>(costPerHour);
    return json;
  }

  ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRoleRole({
    required this.id,
    required this.name,
    required this.costPerHour,
  });
}

@immutable
class ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRoleShift {
  final String id;
  final String title;
  final Timestamp? date;
  final String? locationAddress;
  ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRoleShift.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  title = nativeFromJson<String>(json['title']),
  date = json['date'] == null ? null : Timestamp.fromJson(json['date']),
  locationAddress = json['locationAddress'] == null ? null : nativeFromJson<String>(json['locationAddress']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRoleShift otherTyped = other as ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRoleShift;
    return id == otherTyped.id && 
    title == otherTyped.title && 
    date == otherTyped.date && 
    locationAddress == otherTyped.locationAddress;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, title.hashCode, date.hashCode, locationAddress.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['title'] = nativeToJson<String>(title);
    if (date != null) {
      json['date'] = date!.toJson();
    }
    if (locationAddress != null) {
      json['locationAddress'] = nativeToJson<String?>(locationAddress);
    }
    return json;
  }

  ListRecentPaymentsByStaffIdRecentPaymentsApplicationShiftRoleShift({
    required this.id,
    required this.title,
    this.date,
    this.locationAddress,
  });
}

@immutable
class ListRecentPaymentsByStaffIdRecentPaymentsInvoice {
  final String id;
  final String invoiceNumber;
  final EnumValue<InvoiceStatus> status;
  final Timestamp issueDate;
  final Timestamp dueDate;
  final double amount;
  final ListRecentPaymentsByStaffIdRecentPaymentsInvoiceBusiness business;
  final ListRecentPaymentsByStaffIdRecentPaymentsInvoiceVendor vendor;
  final ListRecentPaymentsByStaffIdRecentPaymentsInvoiceOrder order;
  ListRecentPaymentsByStaffIdRecentPaymentsInvoice.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  invoiceNumber = nativeFromJson<String>(json['invoiceNumber']),
  status = invoiceStatusDeserializer(json['status']),
  issueDate = Timestamp.fromJson(json['issueDate']),
  dueDate = Timestamp.fromJson(json['dueDate']),
  amount = nativeFromJson<double>(json['amount']),
  business = ListRecentPaymentsByStaffIdRecentPaymentsInvoiceBusiness.fromJson(json['business']),
  vendor = ListRecentPaymentsByStaffIdRecentPaymentsInvoiceVendor.fromJson(json['vendor']),
  order = ListRecentPaymentsByStaffIdRecentPaymentsInvoiceOrder.fromJson(json['order']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStaffIdRecentPaymentsInvoice otherTyped = other as ListRecentPaymentsByStaffIdRecentPaymentsInvoice;
    return id == otherTyped.id && 
    invoiceNumber == otherTyped.invoiceNumber && 
    status == otherTyped.status && 
    issueDate == otherTyped.issueDate && 
    dueDate == otherTyped.dueDate && 
    amount == otherTyped.amount && 
    business == otherTyped.business && 
    vendor == otherTyped.vendor && 
    order == otherTyped.order;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, invoiceNumber.hashCode, status.hashCode, issueDate.hashCode, dueDate.hashCode, amount.hashCode, business.hashCode, vendor.hashCode, order.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['invoiceNumber'] = nativeToJson<String>(invoiceNumber);
    json['status'] = 
    invoiceStatusSerializer(status)
    ;
    json['issueDate'] = issueDate.toJson();
    json['dueDate'] = dueDate.toJson();
    json['amount'] = nativeToJson<double>(amount);
    json['business'] = business.toJson();
    json['vendor'] = vendor.toJson();
    json['order'] = order.toJson();
    return json;
  }

  ListRecentPaymentsByStaffIdRecentPaymentsInvoice({
    required this.id,
    required this.invoiceNumber,
    required this.status,
    required this.issueDate,
    required this.dueDate,
    required this.amount,
    required this.business,
    required this.vendor,
    required this.order,
  });
}

@immutable
class ListRecentPaymentsByStaffIdRecentPaymentsInvoiceBusiness {
  final String id;
  final String businessName;
  ListRecentPaymentsByStaffIdRecentPaymentsInvoiceBusiness.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  businessName = nativeFromJson<String>(json['businessName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStaffIdRecentPaymentsInvoiceBusiness otherTyped = other as ListRecentPaymentsByStaffIdRecentPaymentsInvoiceBusiness;
    return id == otherTyped.id && 
    businessName == otherTyped.businessName;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, businessName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['businessName'] = nativeToJson<String>(businessName);
    return json;
  }

  ListRecentPaymentsByStaffIdRecentPaymentsInvoiceBusiness({
    required this.id,
    required this.businessName,
  });
}

@immutable
class ListRecentPaymentsByStaffIdRecentPaymentsInvoiceVendor {
  final String id;
  final String companyName;
  ListRecentPaymentsByStaffIdRecentPaymentsInvoiceVendor.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  companyName = nativeFromJson<String>(json['companyName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStaffIdRecentPaymentsInvoiceVendor otherTyped = other as ListRecentPaymentsByStaffIdRecentPaymentsInvoiceVendor;
    return id == otherTyped.id && 
    companyName == otherTyped.companyName;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, companyName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['companyName'] = nativeToJson<String>(companyName);
    return json;
  }

  ListRecentPaymentsByStaffIdRecentPaymentsInvoiceVendor({
    required this.id,
    required this.companyName,
  });
}

@immutable
class ListRecentPaymentsByStaffIdRecentPaymentsInvoiceOrder {
  final String id;
  final String? eventName;
  final ListRecentPaymentsByStaffIdRecentPaymentsInvoiceOrderTeamHub teamHub;
  ListRecentPaymentsByStaffIdRecentPaymentsInvoiceOrder.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  eventName = json['eventName'] == null ? null : nativeFromJson<String>(json['eventName']),
  teamHub = ListRecentPaymentsByStaffIdRecentPaymentsInvoiceOrderTeamHub.fromJson(json['teamHub']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStaffIdRecentPaymentsInvoiceOrder otherTyped = other as ListRecentPaymentsByStaffIdRecentPaymentsInvoiceOrder;
    return id == otherTyped.id && 
    eventName == otherTyped.eventName && 
    teamHub == otherTyped.teamHub;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, eventName.hashCode, teamHub.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    if (eventName != null) {
      json['eventName'] = nativeToJson<String?>(eventName);
    }
    json['teamHub'] = teamHub.toJson();
    return json;
  }

  ListRecentPaymentsByStaffIdRecentPaymentsInvoiceOrder({
    required this.id,
    this.eventName,
    required this.teamHub,
  });
}

@immutable
class ListRecentPaymentsByStaffIdRecentPaymentsInvoiceOrderTeamHub {
  final String address;
  final String? placeId;
  final String hubName;
  ListRecentPaymentsByStaffIdRecentPaymentsInvoiceOrderTeamHub.fromJson(dynamic json):
  
  address = nativeFromJson<String>(json['address']),
  placeId = json['placeId'] == null ? null : nativeFromJson<String>(json['placeId']),
  hubName = nativeFromJson<String>(json['hubName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStaffIdRecentPaymentsInvoiceOrderTeamHub otherTyped = other as ListRecentPaymentsByStaffIdRecentPaymentsInvoiceOrderTeamHub;
    return address == otherTyped.address && 
    placeId == otherTyped.placeId && 
    hubName == otherTyped.hubName;
    
  }
  @override
  int get hashCode => Object.hashAll([address.hashCode, placeId.hashCode, hubName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['address'] = nativeToJson<String>(address);
    if (placeId != null) {
      json['placeId'] = nativeToJson<String?>(placeId);
    }
    json['hubName'] = nativeToJson<String>(hubName);
    return json;
  }

  ListRecentPaymentsByStaffIdRecentPaymentsInvoiceOrderTeamHub({
    required this.address,
    this.placeId,
    required this.hubName,
  });
}

@immutable
class ListRecentPaymentsByStaffIdData {
  final List<ListRecentPaymentsByStaffIdRecentPayments> recentPayments;
  ListRecentPaymentsByStaffIdData.fromJson(dynamic json):
  
  recentPayments = (json['recentPayments'] as List<dynamic>)
        .map((e) => ListRecentPaymentsByStaffIdRecentPayments.fromJson(e))
        .toList();
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStaffIdData otherTyped = other as ListRecentPaymentsByStaffIdData;
    return recentPayments == otherTyped.recentPayments;
    
  }
  @override
  int get hashCode => recentPayments.hashCode;
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['recentPayments'] = recentPayments.map((e) => e.toJson()).toList();
    return json;
  }

  ListRecentPaymentsByStaffIdData({
    required this.recentPayments,
  });
}

@immutable
class ListRecentPaymentsByStaffIdVariables {
  final String staffId;
  late final Optional<int>offset;
  late final Optional<int>limit;
  @Deprecated('fromJson is deprecated for Variable classes as they are no longer required for deserialization.')
  ListRecentPaymentsByStaffIdVariables.fromJson(Map<String, dynamic> json):
  
  staffId = nativeFromJson<String>(json['staffId']) {
  
  
  
    offset = Optional.optional(nativeFromJson, nativeToJson);
    offset.value = json['offset'] == null ? null : nativeFromJson<int>(json['offset']);
  
  
    limit = Optional.optional(nativeFromJson, nativeToJson);
    limit.value = json['limit'] == null ? null : nativeFromJson<int>(json['limit']);
  
  }
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final ListRecentPaymentsByStaffIdVariables otherTyped = other as ListRecentPaymentsByStaffIdVariables;
    return staffId == otherTyped.staffId && 
    offset == otherTyped.offset && 
    limit == otherTyped.limit;
    
  }
  @override
  int get hashCode => Object.hashAll([staffId.hashCode, offset.hashCode, limit.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['staffId'] = nativeToJson<String>(staffId);
    if(offset.state == OptionalState.set) {
      json['offset'] = offset.toJson();
    }
    if(limit.state == OptionalState.set) {
      json['limit'] = limit.toJson();
    }
    return json;
  }

  ListRecentPaymentsByStaffIdVariables({
    required this.staffId,
    required this.offset,
    required this.limit,
  });
}

